VERSION 0.8 # https://docs.earthly.dev/docs/earthfile#version
FROM python:3

ARG --global build_dir="_site"


################
# Main targets #
################

# Internal target that builds a base environment with dependencies.
deno-base:
    FROM denoland/deno:alpine
    WORKDIR /workdir

    CACHE --persist /deno-dir/

    COPY deno.json .
    RUN deno install
    # NOTE: if you want to vendor your dependencies, see https://lume.land/docs/overview/installation/#vendoring

build:
    ARG yama_env="production"
    FROM +deno-base
    WORKDIR /workdir
    ENV YAMA_ENV=$yama_env
    
    COPY . .
    RUN deno task lume

    SAVE ARTIFACT $build_dir build_result AS LOCAL $build_dir



##################
# Helper targets #
##################

# Target that executes an arbitrary command. Run locally with eg. `earthly +exec --push --command="deno install ..."`
# NOTE: Only changes made to `deno.json` will be savd!
exec:
    FROM +deno-base
    ARG command
    WORKDIR /workdir

    COPY . .
    RUN $command

    SAVE ARTIFACT deno.json AS LOCAL deno.json


# Run `deno task lume --serve` with $PWD mounted. Run locally with `earthly +dev`.
# Note that if you exit Earthly (eg. via Ctrl+c), Earthly will immediately exit and leave the container running.
# You can manually stop it with `earthly +stop-dev` (or `docker stop earthly-dev-server`).
dev:
    ARG port=3000
    ARG container_name="earthly-dev-server"

    LOCALLY
        WITH DOCKER --load earthly-dev-server-image=+deno-base
            RUN docker run --rm -i \
                        --volume="$PWD":/workdir:Z \
                        --publish $port:3000 \
                        --name="$container_name" \
                        earthly-dev-server-image \
                        deno task lume --serve --port 3000
        END

stop-dev:
    ARG container_name="earthly-dev-server"

    LOCALLY
        RUN docker stop $container_name



################
# Swift upload #
################

{% include "./fragments/swift.earth" %}
